#!/usr/bin/perl

# This ArborHosting script will remove all special characters from all
# filenames in the directory in which it is run.   July 31, 2008 ArborHosting

print "Content-Type: text/html\n\n";
print "Removing special characters from filenames...<br>\n";

opendir(DIR, ".");
@files = readdir(DIR); closedir(DIR);

foreach $oldname (@files) {
    # skip directories
    next if ($oldname eq "." || $oldname eq ".." || -d $oldname);
    $newname = $oldname;
    $newname =~ s/[^\w^\.^\-^_^~^#^@]//g; # allowable characters

    # make sure new name does not exist
    if ($newname ne $oldname) {
        while (-e $newname) {
            $newname .= "~";
        }

        if (rename($oldname, $newname)) {
            print "&nbsp;&nbsp; $oldname &rarr; $newname<br>\n";
        } else {
            print "<b>Error renaming $oldname to $newname</b><br>\n";
        }
    }
}
